//////////////////////////////////////////////////////////////////////////
//                                                                      //
// modf.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:08p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// modf --
//
//        
//
double modf(double f, double* i){
	LONG m, r;
	int e, s, sc;
	DstrDouble(f, m, e, s);         //   double

	if (e < 0){
		*i = 0;                     //  ConstructDouble(0, -0x3ff, s, 0);
		return f;
	}

	if (e > 51){	
		if (e==0x400 && m!=0)       //  NAN
			return f;
		*i=f;
		return 0;                   //  ConstructDouble(0, -0x3ff, s, 0);
	}
	
    //   
	r = m & (0x000fffffffffffff >> e);
	m -= r;

	//    
	*i = ConstructDouble(m, e, s, 0);

	r <<= e;
	sc=0;
	//    
	if (r){
		while (!(r & 0x0010000000000000)){
			r <<=1;
			sc--;
		}
    	//    
		return ConstructDouble(r, sc, s, 0);
	}
	else
		return 0;
}

#ifdef __cplusplus
}
#endif
